<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
      <el-form-item :label="$t('中文名称')" prop="titleZh">
        <el-input v-model="queryParams.titleZh" :placeholder="$t('请输入中文名称')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('英文名称')" prop="titleEn">
        <el-input v-model="queryParams.titleEn" :placeholder="$t('请输入英文名称')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('语言')" prop="language">
        <el-input v-model="queryParams.language" :placeholder="$t('请输入语言')" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item :label="$t('状态')" prop="status">
        <el-select v-model="queryParams.status" :placeholder="$t('请选择状态')" clearable>
          <el-option v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>
      <el-form-item :label="$t('类型')" prop="type">
        <el-select v-model="queryParams.type" :placeholder="$t('请选择类型')" clearable>
          <el-option v-for="dict in regionTypeDatas" :key="parseInt(dict.value)" :label="dict.label" :value="parseInt(dict.value)"/>
        </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:region:create']">{{ $t('新增') }}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="info" plain icon="el-icon-sort" size="mini" @click="toggleExpandAll">展开/折叠</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
  <!--列表-->
    <el-table v-if="refreshTable" v-loading="loading" :data="regionList" row-key="id" :default-expand-all="isExpandAll"
              :tree-props="{children: 'children', hasChildren: 'hasChildren'}">
      <el-table-column prop="titleZh" :label="$t('中文名称')" width="200"></el-table-column>
      <el-table-column prop="titleEn" :label="$t('英文名称')" width="200"></el-table-column>
      <el-table-column prop="shortName" :label="$t('简称')"  width="120"/>
      <el-table-column :label="$t('语言')" width="120" align="center" prop="language" />
      <el-table-column prop="sort" :label="$t('排序')" width="50"></el-table-column>
      <el-table-column prop="type" :label="$t('类型')" width="120">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.ECW_REGION_TYPE" :value="scope.row.type"/>
        </template>
      </el-table-column>
<!--      <el-table-column prop="parentId" :label="$t('父节点')" width="200"></el-table-column>-->
      <el-table-column prop="status" :label="$t('状态')" width="100">
<!--        <template slot-scope="scope">-->
<!--          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status"/>-->
<!--        </template>-->
        <template slot-scope="scope">
          <el-switch v-model="scope.row.status" :active-value="0" :inactive-value="1" @change="handleStatusChange(scope.row)" />
        </template>
      </el-table-column>
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" width="200">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:region:update']">{{ $t('修改') }}</el-button>
          <el-button size="mini" type="text" icon="el-icon-plus" @click="handleAdd(scope.row)"
                     v-hasPermi="['ecw:region:create']">{{ $t('新增') }}</el-button>
          <el-button v-if="scope.row.parentId !== 0" size="mini" type="text" icon="el-icon-delete"
                     @click="handleDelete(scope.row)" v-hasPermi="['ecw:region:delete']">{{ $t('删除') }}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改部门对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="24">
            <el-form-item :label="$t('上级区域')" prop="parentId">
              <treeselect v-model="form.parentId" :options="regionOptions" :normalizer="normalizer" :placeholder="$t('选择上级区域')" />
            </el-form-item>
          </el-col>
          <el-form-item :label="$t('中文名称')" prop="titleZh">
            <el-input v-model="form.titleZh" :placeholder="$t('请输入中文名称')" />
          </el-form-item>
          <el-form-item :label="$t('英文名称')" prop="titleEn">
            <el-input v-model="form.titleEn" :placeholder="$t('请输入英文名称')" />
          </el-form-item>
          <el-form-item :label="$t('简称')" prop="shortName">
            <el-input v-model="form.shortName" :placeholder="$t('请输入简称')" />
          </el-form-item>
          <el-form-item :label="$t('语言')" prop="language">
            <el-input v-model="form.language" :placeholder="$t('请输入语言')" />
          </el-form-item>
          <el-form-item :label="$t('类型')" prop="type">
          <el-select v-model="form.type" :placeholder="$t('请选择')">
            <el-option v-for="dict in regionTypeDatas" :key="dict.value" :label="dict.label" :value="dict.value"/>
          </el-select>
          </el-form-item>
          <el-form-item :label="$t('国家城市代码')" prop="labelCode" v-if="form.type == '1' || form.type == '3' ">
            <el-input v-model="form.labelCode" placeholder="请输入国家代码-城市代码" />
          </el-form-item>
          <el-form-item :label="$t('显示顺序')" prop="sort">
            <el-input v-model="form.sort" :placeholder="$t('请输入显示顺序')" />
          </el-form-item>
<!--          <el-col :span="12">-->
<!--            <el-form-item :label="$t('部门状态')" prop="status">-->
<!--              <el-radio-group v-model="form.status">-->
<!--                <el-radio v-for="dict in statusDictDatas" :key="parseInt(dict.value)" :label="parseInt(dict.value)">-->
<!--                  {{dict.label}}</el-radio>-->
<!--              </el-radio-group>-->
<!--            </el-form-item>-->
<!--          </el-col>-->
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('确 定') }}</el-button>
        <el-button @click="cancel">{{ $t('取 消') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
// import { listDept, getDept, delDept, addDept, updateDept } from "@/api/system/dept";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listSimpleUsers} from "@/api/system/user";

import {CommonStatusEnum} from '@/utils/constants'
import { getDictDatas, DICT_TYPE } from '@/utils/dict'
import {
  getRegion,
  getRegionList,
  getRegionPage,
  updateRegion,
  createRegion,
  deleteRegion,
  updateRegionStatus
} from "@/api/ecw/region";
import {changeUserStatus} from "@/api/system/user";
import {updateBankAccount} from "@/api/ecw/bankAccount";

export default {
  name: "Region",
  components: { Treeselect },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 表格树数据
      regionList: [],
      // 部门树选项
      regionOptions: [],
      // 用户下拉列表
      users: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 是否展开，默认全部展开
      isExpandAll: true,
      // 重新渲染表格状态
      refreshTable: true,
      // 是否展开
      expand: false,
      // 状态数据字典
      statusOptions: [],
      // 查询参数
      queryParams: {
        titleZh: undefined,
        titleEn: undefined,
        shortName: undefined,
        status: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        titleZh: [{ required: true, message: this.$t("中文名称不能为空"), trigger: "blur" }],
        titleEn: [{ required: true, message: this.$t("英文名称不能为空"), trigger: "blur" }],
        shortName: [{ required: true, message: this.$t("简称不能为空"), trigger: "blur" }],
        // language: [{ required: true, message: this.$t("语言不能为空"), trigger: "blur" }],
        labelCode: [{ required: true, message: this.$t("国家城市代码不能为空"), trigger: "blur" }],
        // type: [{ required: true, message: this.$t("类型不能为空"), trigger: "change" }],
        // parentId: [{ required: true, message: "父区域id不能为空", trigger: "blur" }],
        sort: [{ required: true, message: this.$t("显示顺序不能为空"), trigger: "blur" }],
      },

      // 枚举
      CommonStatusEnum: CommonStatusEnum,
      // 数据字典
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),
      regionTypeDatas: getDictDatas(DICT_TYPE.ECW_REGION_TYPE)
    };
  },
  created() {
    this.getList();
    // 获得用户列表
    listSimpleUsers().then(response => {
      this.users = response.data;
    });
    // console.log("regionTypeDatas:"+JSON.stringify(regionTypeDatas));
  },
  methods: {
    /** 查询部门列表 */
    getList() {
      this.loading = true;
      getRegionList(this.queryParams).then(response => {
        // console.log("response:"+JSON.stringify(response.data));
        this.regionList = this.handleTree(response.data, "id");
        this.loading = false;
      });
    },
    /** 转换部门数据结构 */
    normalizer(node) {
      // console.log("normalizer:"+JSON.stringify(node)+" node.children:"+JSON.stringify(node.children));
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.id,
        label: node.titleZh,
        children: node.children
      };
    },
    // 用户昵称展示
    // userNicknameFormat(row, column) {
    //   if (!row.leaderUserId) {
    //     return this.$t('未设置');
    //   }
    //   for (const user of this.users) {
    //     if (row.leaderUserId === user.id) {
    //       return user.nickname;
    //     }
    //   }
    //   return this.$t('未知【') + row.leaderUserId + this.$t('】');
    // },
    // 用户状态修改
    handleStatusChange(row) {
      let text = row.status === CommonStatusEnum.ENABLE ? this.$t("启用") : this.$t("停用");
      this.$modal.confirm('确认要' + text + this.$t('编号为') + row.id + '的数据吗?').then(function() {
        // return changeUserStatus(row.id, row.status);
        console.log("row.status:"+row.status);
        return updateRegionStatus({id:row.id,status:row.status});

      }).then(() => {
        this.$modal.msgSuccess(text + "成功");
      }).catch(function() {
        row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE
          : CommonStatusEnum.ENABLE;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: undefined,
        parentId: undefined,
        name: undefined,
        sort: undefined,
        leaderUserId: undefined,
        phone: undefined,
        email: undefined,
        status: CommonStatusEnum.ENABLE,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      if (row !== undefined) {
        this.form.parentId = row.id;
      }
      this.open = true;
      this.title = this.$t("添加区域");
      getRegionList().then(response => {
        // console.log("添加区域查询结果:"+JSON.stringify(response.data));
        this.regionOptions = this.handleTree(response.data, "id");
        // console.log("regionOptions:"+JSON.stringify(this.regionOptions));
      });
    },
    /** 展开/折叠操作 */
    toggleExpandAll() {
      this.refreshTable = false;
      this.isExpandAll = !this.isExpandAll;
      this.$nextTick(() => {
        this.refreshTable = true;
      });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      getRegion(row.id).then(response => {
        this.form = response.data;
        // console.log("getRegion("+row.id+"):"+JSON.stringify(this.form));
        if (this.form.parentId === 0) { // 无父部门时，标记为 undefined，避免展示为 Unknown
          this.form.parentId = undefined;
        }
        this.open = true;
        this.title = this.$t("修改区域");
      });
      getRegionList(row.id).then(response => {
        // console.log("getRegionList("+row.id+"):"+JSON.stringify(response.data));
        this.regionOptions = this.handleTree(response.data, "id");
        // console.log("getRegionList("+row.id+"):  regionOptions"+JSON.stringify(this.regionOptions));

      });
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id !== undefined) {
            updateRegion(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            createRegion(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除名称为"' + row.titleZh + '"的数据项?').then(function() {
        return deleteRegion(row.id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    }
  }
};
</script>
